<?php
# ComBack for DotClear
# (c)2006 Jihem
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

require dirname(__FILE__).'/config.php';

# Fonctions ct blog
class dcComback {
	# Affichage du nombre de combacks
	#---
	# Les 3 premiers arguments permettent de dfinir le texte affich
        # pour respectivement aucun, un, ou plusieurs commentaires.
	# Le 4e argument est affich devant le nombre de combacks si la
	# chane n'est pas vide
	function PostNbCombacks($zero,$one,$more,$prefix='')
	{
		global $blog;
		$t_comback = DB_PREFIX.'comback';
		$post_id = $GLOBALS['news']->f('post_id');

		$strReq = "select count(*)
			from $t_comback cb, $blog->t_comment c
			where cb.comment_id=c.comment_id and c.post_id=$post_id";

		# Rcupration
		if (!($cb = $blog->con->select($strReq)))
			return false;
		$nb = $cb->f(0);
		
		# Formatage
		if($nb == 0)
			$str = $zero;
		elseif($nb == 1)
			$str = $one;
		else
			$str = sprintf($more,$nb);
		if (!$str)
			return true;
		$str = "$prefix<span class=\"nb_combacks\">$str</span>";

		# Affichage
		echo $str;
		
		return true;
	}
	
	# Affichage d'un comback
	function display()
	{
		global $blog, $comback_display_str;
		$t_comback = DB_PREFIX.'comback';
		$comment_id = $GLOBALS['comments']->f('comment_id');
		
		$strReq = "select cb.comback_dt, cb.comback_content,
			u.user_pseudo, u.user_prenom, u.user_nom
			from $t_comback cb, $blog->t_user u
			where cb.comment_id = $comment_id and cb.user_id = u.user_id";

		# Rcupration
		if (!($cb = $blog->con->select($strReq)))
			return false;
		if($cb->isEmpty())
			return true;

		# Formatage
		$ts = strtotime($cb->f('comback_dt'));
		$comback_date = dt::str($blog->date_format, $ts);
		$comback_time = dt::str($blog->time_format, $ts);
		$comback_author = ($cb->f('user_pseudo') != '' ?
	       		$cb->f('user_pseudo') :
			$cb->f('user_prenom').' '.$cb->f('user_nom')
		);
		$comback_content = $cb->f('comback_content');
		if ($blog->use_smilies)
			$comback_content = $blog->addSmilies($comback_content);

		# Affichage
		eval('echo <<<EOT
'.$comback_display_str.'
EOT
;');
		return true;
	}

	# Lien vers le fil RSS des rponses + combacks
	function rss($post_id)
	{
		echo dc_app_url.'/'.DC_ECRIRE."/tools/comback/rss.php?type=cb&post=$post_id";
		return true;
	}
}
	
?>
